-- Create namespace
DsRdefaults = {}
local DsRdefaults = DsRdefaults  or {}

DsRdefaults.name = "DsRdefaults"
-------------------------------------------------------------------------------------------------------------------------------------------------
function copyDeep(orig)
    local orig_type = type(orig)
    local copy
    if orig_type == 'table' then
        copy = {}
        for orig_key, orig_value in next, orig, nil do
            copy[copyDeep(orig_key)] = copyDeep(orig_value)
        end
        setmetatable(copy, copyDeep(getmetatable(orig)))
    else
        copy = orig
    end
    return copy
end

function DsRdefaults:Defaults()

    local defAutoInvite = {
        maxSize        = 12,
        restart        = true,
        cyrCheck       = false,
        autoKick       = true,
        kickDelay      = 400,
        watchStr       = "",
        showPanel      = true,
        ShowGroupJoin  = true,
        HideGroupLeave = true,
        ResetTable     = true,
        ColorTitle     = {0.6196078658, 0.7098039389, 0.8039215803, 1},
        ColorPlayer    = {1, 1, 1, 1},
        ColorCount     = {1, 0.1921568662, 0.1960784346, 1},
        TableLenght    = 10,
        TableOffsetX   = 20,
        TableOffsetY   = 75,
        DeathbgAlpha   = 50,
    }

    local defLootManager = {
        ScreenfNirn       = true,
        ScreensNirn       = true,
        ScreenKuta        = true,
        ScreenHakeijo     = true,
        ScreenLuminousInk = true,
        ScreenRubyblossom = true,
        ScreenMourningdew = true,
        ScreenPerfectRoe  = true,
        ScreenAetherialDust  = true,
        ScreenAethericCipher = true,
        ScreenTradePrice = true,
        ScreenOnOff      = false,
        ScreenQualiloot  = "3 - |c259EFAÜberragend|r",
        ScreenBestrebung = true,

        ChatfNirn             = true,
        ChatsNirn             = true,
        ChatKuta              = true,
        ChatHakeijo           = true,
        ChatLuminousInk       = true,
        ChatRubyblossom       = true,
        ChatMourningdew       = true,
        ChatPerfectRoe        = true,
        ChatAetherialDust     = true,
        ChatAethericCipher    = true,
        ChatTradePrice        = true,
        ChatOnOff             = false,
        ChatQualiloot         = "3 - |c259EFAÜberragend|r",
        ChatGroupLoot         = true,
        ChatQualiGroupLoot    = "3 - |c259EFAÜberragend|r",
        ChatArchivments       = true,
        ChatArchivmentsStatus = true,
        ChatXP                = false,
        ChatXPtxt             = "1150",
        ChatGold              = true,
        ChatGoldtxt           = "500",
        ChatUnerschrocken     = true,
        Chatetickets          = true,
        ChatTransmut          = true,
        ChatBestrebung        = true,
        ChatEndless           = true,
        ChatBookLoot          = true,
        ChatXPskills          = true,
        ChatXPweapon          = true,
        ChatXParmor           = true,
        ChatXPguild           = true,
        ChatXPava             = true,
        ChatXPexcavation      = true,
        ChatXPscrying         = true,
        ChatXPlegerdemain     = true,
        ChatXPsoulmagic       = true,
        ChatXPvampire         = true,
        ChatXPwerewolf        = true,
        ChatXPcrafting        = true,
        ChatXPblacksmithing   = true,
        ChatXPclothier        = true,
        ChatXPenchanting      = true,
        ChatXPalchemy         = true,
        ChatXPprovisioner     = true,
        ChatXPwoodworking     = true,
        ChatXPjewelrymaking   = true,

        DsRReminderfoodOnOff  = true,
        DsRReminderfoodfalse  = true,
        DsRReminderBuffFoodMinTime = "5",
        DsRReminderxpOnOff     = true,
        DsRReminderxpfalse     = false,
        DsRReminderxpMinTime   = "2",
        DsRReminderapOnOff     = true,
        DsRReminderapfalse     = false,
        DsRReminderapMinTime   = "2",

        DsRDailyCraftAlchemy   = true,
        DsRDailyCraftProvision = true,

        PreCraftProfessions = {
            [CRAFTING_TYPE_BLACKSMITHING]   = true,
            [CRAFTING_TYPE_CLOTHIER]        = true,
            [CRAFTING_TYPE_WOODWORKING]     = true,
            [CRAFTING_TYPE_JEWELRYCRAFTING] = true,
            [CRAFTING_TYPE_ENCHANTING]      = true,
        },
    }

    local defstickerbook = {
        autoBind         = false,
        show = {
            bag        = true,
            bank       = true,
            housebank  = true,
            guild      = true,
            guildstore = true,
            crafting   = true,
            transmute  = true,
            trading    = true,
        },
        chatSystemShow   = true,
        chatMessageShow  = true,
        iconOffset       = 0,
        iconStoreOffset  = 0,
        showRequestLink  = true,
        requestInWhisper = true,
        requestPrefix    = GetString(DsRGuildBind_req_requestPrefixdefault),
        Chatuncollect    = false,
    }
    
    local defpvpDeep = {
        kills 		   = 0,		-- Total number of kills in which player has been involved
        killingBlowsAD = 0, 	-- Aldmeri    - number of killing blows player has dealt
        killingBlowsEP = 0, 	-- Ebenerz    - number of killing blows player has dealt
        killingBlowsDC = 0, 	-- Dolchsturz - number of killing blows player has dealt
        deaths 		   = 0,		-- Total number of times player has died in PvP
        alliancePoints = 0,		-- AP gained
        telvarPoints   = 0 		-- TelVar gained
    }

    local defpvp = {
        PvPAP                  = true,
        PvPAPvalue             = "150",
        PvPAPrep               = true,
        PvPAPdeath             = true,
        PvPAPoffenschat        = true,
        PvPAPoffensscreen      = true,
        PvPAPdeffenschat       = true,
        PvPAPdeffensscreen     = true,
        PvPAPressurect         = true,
        PvPAPmedal             = true,
        PvPAPmatch             = true,
        PvPAPquest             = true,
        PvPTelVar              = true,
        PvPTelVarSaver         = 0,
        PvPTelVarSaverQAsGroup = false,
        PvPCakeRem             = true,
        PvPKillenableFrame     = true,
        PvPKillframeColor      = {0.51764708757041, 1, 0.24705882370472, 1},
        PvPKillBlowChat        = true,
        PvPKillScreen          = true,
        PvPKillChat            = true,
        enableQueueBar         = true,
        statsBarLocked         = false,
        hideInPvE 		       = true,
        sessionStats 	       = copyDeep(defpvpDeep),
        scoreWindowScale       = 0,
        scoreWindowanchorPoint = 9,
        scoreWindowxOff        = -350,
        scoreWindowyOff        = -100,
        PvPdoorOnOff           = true,
        PvPdoorPinRGB = {
            r = 0.5176470876,
            g = 1,
            b = 0.5803921819
        },
        PvPdoorPinSize  = 20,
        PvPdoorPinLevel = 100,
        PvPdoorImperial = true,

        PvPtimetable              = true,
        PvPtimetableTop           = 0,
        PvPtimetableLeft          = 0,
        PvPeventtimers            = false,
        PvPmaptimers              = true,
        PvPccw_cw                 = false,
        PvPsaved_timers           = {},
                
        PvPstatusenabled            = true,
        PvPstatuspositionLocked     = false,
        PvPstatusshowKeeps          = true,
        PvPstatusshowResources      = true,
        PvPstatusshowOutposts       = true,
        PvPstatusshowVillages       = true,
        PvPstatusshowTemples        = true,
        PvPstatusshowDestructibles  = true,
        PvPstatusdefaultColor = {
            r = 1,
            g = 1,
            b = 1
        },
        PvPstatuscooldownColor = {
            r = 0,
            g = 1,
            b = 0
        },
        PvPstatusflipsAtPositiveColor = {
            r = 0,
            g = 1,
            b = 0
        },
        PvPstatusflipsAtNegativeColor = {
            r = 1,
            g = 0,
            b = 0
        },
        PvPstatushideOnWorldMap   = true,
        PvPstatusshowFlags        = true,
        PvPstatusshowSieges       = true,
        PvPstatusshowOwnerChanges = true,
        PvPstatusshowActionTimers = true,
        PvPstatusshowBackground   = false,
    }
    
    local defAllianceColor = {
        DsRColorad = {
            r = 0.734375,
            g = 0.64453125,
            b = 0.27734375
        },
        DsRColorep = {
            r = 0.8671875,
            g = 0.35546875,
            b = 0.3046875
        },
        DsRColordc = {
            r = 0.30859375,
            g = 0.50390625,
            b = 0.73828125
        },
        DsRColornoAlliance = {
            r = 1,
            g = 1,
            b = 1
        },
    }
    
    DsRAutoINV.cfg               = ZO_SavedVars:NewAccountWide("DsRGuildRosterSettings", 1, "AutoInvite", defAutoInvite)
    DsRGuildLoot.sV              = ZO_SavedVars:NewAccountWide("DsRGuildRosterSettings", 1, "LootManager", defLootManager)
    DsRGuildPvP.pvp              = ZO_SavedVars:NewAccountWide("DsRGuildRosterSettings", 1, "PvP", defpvp)
    DsRGuildPvP.Acol             = ZO_SavedVars:NewAccountWide("DsRGuildRosterSettings", 1, "AllianceColor", defAllianceColor)
    DsRGuildBind.bind            = ZO_SavedVars:NewAccountWide("DsRGuildRosterSettings", 1, "CollectionBind", defstickerbook)
end