-- Create namespace
DsRGuildAlchemy = {}
local DsRGuildAlchemy = DsRGuildAlchemy  or {}

DsRGuildAlchemy.name = "DsRGuildAlchemy"

DsRGuildAlchemy.Alchemy = {
    ["Level"] = {
      --Potion base
      [71] = 883,
      [72] = 1187,
      [74] = 4570,
      [76] = 23265,
      [78] = 23266,
      [141] = 23267,
      [142] = 23268,
      [198] = 64500,
      [199] = 64501,
      --Poison base
      [231] = 75357,
      [232] = 75358,
      [233] = 75359,
      [234] = 75360,
      [235] = 75361,
      [236] = 75362, 
      [237] = 75363,
      [238] = 75364, 
      [239] = 75365, 
    },
    ["Reagents"] ={                  -- Current Price
      77587,  --Fleshfly Larva              64
      30148,  --Blue Entoloma               66
      30162,  --Dragonthorn                 66
      30154,  --White Cap                   68
      30159,  --Wormwood                    75
      30155,  --Luminous Russula            79
      77584,  --Spider Egg                  79
      30166,  --Water Hyacinth              81
      30165,  --Nirnroot                    81
      30157,  --Blessed Thistle             82
      30153,  --Namira's Rot                84
      30158,  --Lady's Smock                88
      77585,  --Butterfly Wing              90
      30149,  --Stinkhorn                   94
      30156,  --Imp Stool                   108
      150789, --Dragon's Bile               113
      77590,  --Nightshade                  118
      30151,  --Emetic Russula              124
      30161,  --Corn Flower                 134
      77583,  --Beetle Scuttle              176
      30163,  --Mountain Flower             231
      30160,  --Bugloss                     295
      77589,  --Scrib Jelly                 410
      150672, --Crimson Nirnroot            523
      150670, --Vile Coagulant              626
      77591,  --Mudcrab Chitin              658
      77581,  --Torchbug Thorax             726
      139020, --Clam Gall                   791
      150669, --Chaurus Egg                 825
      
      30152,  --Violet Coprinus             1019
      30164,  --Columbine                   1651
      139019, --Powdered Mother of Pearl    2016
      
      150731, --Dragon's Blood              3809
      150671, --Dragon Rheum                7793
    },
  }
  
local function ToLink(Id)
  if not Id then return "" end
  return "|H0:item:"..Id..":30:1:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0:0|h|h"
end

function DsRGuildAlchemy.HandleAlchemy(a, b)
    local _
    local Tep = {}
    local CraftType = 0
    local Material = 0
    
    local current, need = GetJournalQuestConditionValues(a, 1, b)
    Tep[3] = need - current
    if Tep[3] == 0 then return end
    
    Tep[2], Material, CraftType = GetQuestConditionItemInfo(a, 1, b)
    if CraftType == 0 then return end
    Tep[1] = DsRGuildAlchemy.Alchemy["Level"][Material]
  
    table.insert(DsRGuildAlchemy.CraftList ,{
        ["Type"] = CraftType,
        ["Craft"] = Tep,
    })
  end

  function DsRGuildAlchemy.QuestCheck(CurrentType)
    DsRGuildAlchemy.CraftList = {}
    for a = 1, 25 do  --Look up all journal quests
      local Type = select(10, GetJournalQuestInfo(a))  
      if Type == 4 then -- Craft quests
          for b = 1, 6 do --Normal daily craft
            local ItemId, MaterialId, CraftType = GetQuestConditionItemInfo(a, 1, b)
            if CraftType == CurrentType then
                if CraftType == 4 then
                    DsRGuildAlchemy.HandleAlchemy(a, b)
                    return
                end
            end
          end
      end
    end
  end
  
  function DsRGuildAlchemy.CraftCore(scene, _, newstate)
    if DsRGuildLoot.sV.DsRDailyCraftAlchemy == false then return end
    if scene.name ~= "alchemy" then return end
    if newstate == SCENE_HIDING then --Reset
      EVENT_MANAGER:UnregisterForEvent(DsRGuildAlchemy.name, EVENT_INVENTORY_SINGLE_SLOT_UPDATE)
      EVENT_MANAGER:UnregisterForEvent(DsRGuildAlchemy.name, EVENT_CRAFT_COMPLETED)
      EVENT_MANAGER:UnregisterForEvent(DsRGuildAlchemy.name, EVENT_CRAFT_FAILED)
    --   ZO_AlchemyTopLevelSlotContainer:SetHidden(false)
      return
    end
    if newstate ~= SCENE_SHOWN then return end
    
    local CurrentCraft = GetCraftingInteractionType() --current station
    DsRGuildAlchemy.QuestCheck(CurrentCraft) --Find the quest of current station
    DsRGuildAlchemy.CraftList["Stop"] = false --Reset
    EVENT_MANAGER:RegisterForEvent(DsRGuildAlchemy.name, EVENT_CRAFT_FAILED, DsRGuildAlchemy.CraftFail) 
    
    if DsRGuildAlchemy.CraftList[1] ~= nil then
      if CurrentCraft == 4 then
        -- ZO_AlchemyTopLevelSlotContainer:SetHidden(true)
        EVENT_MANAGER:RegisterForEvent(DsRGuildAlchemy.name, EVENT_INVENTORY_SINGLE_SLOT_UPDATE, DsRGuildAlchemy.CraftAlchemy)
        DsRGuildAlchemy.CraftAlchemy(true) 
        return
      end
    end
  end
  
local function FindReagents(ItemId)
    local Table = {}
    --Craft Bag
    if GetItemId(5, ItemId) ~= 0 then table.insert(Table, {5, ItemId}) end
     --bank
    for i = 0, GetBagSize(2) do
      if GetItemId(2, i) == ItemId then table.insert(Table, {2, i}) end
    end
    --Subscriber bank
    if IsESOPlusSubscriber() then 
      for i = 0, GetBagSize(6) do
        if GetItemId(6, i) == ItemId then table.insert(Table, {6, i}) end
      end
    end
    --bag
    for i = 0, GetBagSize(1) do 
      if GetItemId(1, i) == ItemId then table.insert(Table, {1, i}) end
    end
    --Missing
    if not Table[1] then return 0, 0 end
    local BagId, SlotId, Max = 0, 0, 0
    for i = 1, #Table do
      local count = select(2, GetItemInfo(Table[i][1], Table[i][2]))
      if count > Max then
        BagId = Table[i][1]
        SlotId = Table[i][2]
        Max = count
      end
    end
    return BagId, SlotId
  end
  

  function DsRGuildAlchemy.CraftAlchemy(IsFirst, ...)
    local NumChange = select(6, ...) or 0
    if NumChange < 0 then return end
    if IsFirst ~= true then table.remove(DsRGuildAlchemy.CraftList, 1) end
    
    local Table = DsRGuildAlchemy.CraftList[1]
    if Table == nil then
      ZO_AlchemyTopLevelSlotContainer:SetHidden(false)
      if DsRGuildAlchemy.CraftList["Stop"] then return end
      SCENE_MANAGER:Hide("alchemy")
      SCENE_MANAGER:Hide("gamepad_alchemy_mode")
      return
    end
    
    local TotalCombo = {}
    TotalCombo = DsRGuildAlchemy.Alchmy2Craft[Table["Craft"][2]]
  
    local FinalCombo = {} 
    for i = 1, 9 do FinalCombo[i] = 0 end
    
    FinalCombo[1], FinalCombo[2] = FindReagents(Table["Craft"][1])
    if FinalCombo[1] == 0 then
      DsRGuildAlchemy.CraftList["Stop"] = true
      DsRGuildAlchemy.DD(1, {ToLink(Table["Craft"][1])})
      DsRGuildAlchemy.CraftAlchemy()
      return
    end
    
    --Find material info
    local Cost = 0
    for a = 1, #TotalCombo do
      local fBag, fSlot = FindReagents(TotalCombo[a][1])
      local sBag, sSlot = FindReagents(TotalCombo[a][2])
      local tBag, tSlot = FindReagents(TotalCombo[a][3])
      if TotalCombo[a][3] == nil then
        if (fBag*sBag) ~= 0 then
          FinalCombo[3], FinalCombo[4], FinalCombo[5], FinalCombo[6], FinalCombo[7], FinalCombo[8] = fBag, fSlot, sBag, sSlot, nil, nil
          Cost = TotalCombo[a]["Cost"]
          break
        end
      else
        if (fBag*sBag*tBag) ~= 0 then
          FinalCombo[3], FinalCombo[4], FinalCombo[5], FinalCombo[6], FinalCombo[7], FinalCombo[8] = fBag, fSlot, sBag, sSlot, tBag, tSlot
          Cost = TotalCombo[a]["Cost"]
          break
        end
      end
    end
    
    if FinalCombo[3] == 0 or FinalCombo[5] == 0 or FinalCombo[7] == 0 then
      DsRGuildAlchemy.CraftList["Stop"] = true
      local Report = {["Cost"] = TotalCombo[1]["Cost"]}
      for i = 1, 3 do
        if TotalCombo[1][i] ~= nil then
          local Cause = ""
          if FindReagents(TotalCombo[1][i]) == 0 then Cause = GetString(SI_CRAFTING_MISSING_ITEMS) end --Missing
          table.insert(Report, {ToLink(TotalCombo[1][i]), Cause})
        end
      end
      DsRGuildAlchemy.CraftAlchemy()
      return
    end
    --Craft and display cost
    CraftAlchemyItem(unpack(FinalCombo))

    d("|c9fb6cd[DsR-Crafter]|r " .. GetString(DsRGuildCrafting_AlchemyFinish))
  end
  
  function DsRGuildAlchemy.DD(Type, Info) 
    local Table = {}
        --Warning_NO_Material: ItemLink
    if Type == 1 then
        Table[1] = GetString(SI_TRADESKILLRESULT141).." -> "..Info[1]
    end
    if not Table[1] then return end
    DsRGuildAlchemy.Chat(Table)
  end

  function DsRGuildAlchemy.Chat(Table) 
    for i = 1, #Table do
      d("|c9fb6cd[DsR-Crafter]|r "..Table[i])
    end
    return
  end

  function DsRGuildAlchemy.OnAddOnLoaded(eventCode, addonName)
    EVENT_MANAGER:UnregisterForEvent(DsRGuildAlchemy.name, EVENT_ADD_ON_LOADED)
    
    --Register Callback
    SCENE_MANAGER:RegisterCallback("SceneStateChanged", DsRGuildAlchemy.CraftCore)    --Start craft work
  end
  
  DsRGuildAlchemy.Alchmy2Craft = 
    {
      [54336] = 
      {
          [1] = 
          {
              [1] = 30165,
              [2] = 77585,
              ["Pre"] = 195.9500000000,
          },
      },
      [54337] = 
      {
          [1] = 
          {
              [1] = 30165,
              [2] = 30156,
              ["Pre"] = 196.6700000000,
          },
          [2] = 
          {
              [1] = 30165,
              [2] = 77581,
              ["Pre"] = 790.0800000000,
          },
          [3] = 
          {
              [1] = 30156,
              [2] = 77581,
              ["Pre"] = 804.9900000000,
          },
          [4] = 
          {
              [1] = 30165,
              [2] = 150671,
              ["Pre"] = 7468.6700000000,
          },
          [5] = 
          {
              [1] = 30156,
              [2] = 150671,
              ["Pre"] = 7483.5800000000,
          },
          [6] = 
          {
              [1] = 77581,
              [2] = 150671,
              ["Pre"] = 8076.9900000000,
          },
      },
      [30146] = 
      {
          [1] = 
          {
              [1] = 30162,
              [2] = 30159,
              ["Pre"] = 168.2700000000,
          },
          [2] = 
          {
              [1] = 30162,
              [2] = 30166,
              ["Pre"] = 176.7200000000,
          },
          [3] = 
          {
              [1] = 30159,
              [2] = 30166,
              ["Pre"] = 190.0500000000,
          },
      },
      [54339] = 
      {
          [1] = 
          {
              [1] = 30148,
              [2] = 30155,
              ["Pre"] = 165.9600000000,
          },
          [2] = 
          {
              [1] = 30148,
              [2] = 30166,
              ["Pre"] = 178.2500000000,
          },
          [3] = 
          {
              [1] = 30148,
              [2] = 77585,
              ["Pre"] = 184.0700000000,
          },
          [4] = 
          {
              [1] = 30155,
              [2] = 30166,
              ["Pre"] = 186.2100000000,
          },
          [5] = 
          {
              [1] = 30155,
              [2] = 77585,
              ["Pre"] = 192.0300000000,
          },
          [6] = 
          {
              [1] = 30166,
              [2] = 77585,
              ["Pre"] = 204.3200000000,
          },
          [7] = 
          {
              [1] = 30148,
              [2] = 30163,
              ["Pre"] = 353.5600000000,
          },
          [8] = 
          {
              [1] = 30166,
              [2] = 30163,
              ["Pre"] = 373.8100000000,
          },
          [9] = 
          {
              [1] = 77585,
              [2] = 30163,
              ["Pre"] = 379.6300000000,
          },
          [10] = 
          {
              [1] = 30155,
              [2] = 30160,
              ["Pre"] = 423.0300000000,
          },
          [11] = 
          {
              [1] = 30166,
              [2] = 30160,
              ["Pre"] = 435.3200000000,
          },
          [12] = 
          {
              [1] = 77585,
              [2] = 30160,
              ["Pre"] = 441.1400000000,
          },
          [13] = 
          {
              [1] = 30148,
              [2] = 150672,
              ["Pre"] = 491.2000000000,
          },
          [14] = 
          {
              [1] = 30155,
              [2] = 150672,
              ["Pre"] = 499.1600000000,
          },
          [15] = 
          {
              [1] = 77585,
              [2] = 150672,
              ["Pre"] = 517.2700000000,
          },
          [16] = 
          {
              [1] = 30163,
              [2] = 30160,
              ["Pre"] = 610.6300000000,
          },
          [17] = 
          {
              [1] = 30163,
              [2] = 150672,
              ["Pre"] = 686.7600000000,
          },
          [18] = 
          {
              [1] = 30160,
              [2] = 150672,
              ["Pre"] = 748.2700000000,
          },
          [19] = 
          {
              [1] = 30148,
              [2] = 30164,
              ["Pre"] = 2124.1500000000,
          },
          [20] = 
          {
              [1] = 30155,
              [2] = 30164,
              ["Pre"] = 2132.1100000000,
          },
          [21] = 
          {
              [1] = 30166,
              [2] = 30164,
              ["Pre"] = 2144.4000000000,
          },
          [22] = 
          {
              [1] = 77585,
              [2] = 30164,
              ["Pre"] = 2150.2200000000,
          },
          [23] = 
          {
              [1] = 30163,
              [2] = 30164,
              ["Pre"] = 2319.7100000000,
          },
          [24] = 
          {
              [1] = 30160,
              [2] = 30164,
              ["Pre"] = 2381.2200000000,
          },
          [25] = 
          {
              [1] = 150672,
              [2] = 30164,
              ["Pre"] = 2457.3500000000,
          },
      },
      [54340] = 
      {
          [1] = 
          {
              [1] = 30158,
              [2] = 30160,
              ["Pre"] = 439.4300000000,
          },
          [2] = 
          {
              [1] = 30161,
              [2] = 30160,
              ["Pre"] = 498.7500000000,
          },
          [3] = 
          {
              [1] = 30158,
              [2] = 150670,
              ["Pre"] = 563.8700000000,
          },
          [4] = 
          {
              [1] = 30160,
              [2] = 150670,
              ["Pre"] = 796.5800000000,
          },
          [5] = 
          {
              [1] = 30158,
              [2] = 30164,
              ["Pre"] = 2148.5100000000,
          },
          [6] = 
          {
              [1] = 30161,
              [2] = 30164,
              ["Pre"] = 2207.8300000000,
          },
          [7] = 
          {
              [1] = 150670,
              [2] = 30164,
              ["Pre"] = 2505.6600000000,
          },
          [8] = 
          {
              [1] = 30158,
              [2] = 150671,
              ["Pre"] = 7481.1500000000,
          },
          [9] = 
          {
              [1] = 30161,
              [2] = 150671,
              ["Pre"] = 7540.4700000000,
          },
          [10] = 
          {
              [1] = 30160,
              [2] = 150671,
              ["Pre"] = 7713.8600000000,
          },
          [11] = 
          {
              [1] = 150670,
              [2] = 150671,
              ["Pre"] = 7838.3000000000,
          },
          [12] = 
          {
              [1] = 30164,
              [2] = 150671,
              ["Pre"] = 9422.9400000000,
          },
      },
      [54341] = 
      {
          [1] = 
          {
              [1] = 30162,
              [2] = 30163,
              ["Pre"] = 352.0300000000,
          },
          [2] = 
          {
              [1] = 30157,
              [2] = 30163,
              ["Pre"] = 370.4400000000,
          },
          [3] = 
          {
              [1] = 30162,
              [2] = 150669,
              ["Pre"] = 698.3400000000,
          },
          [4] = 
          {
              [1] = 30157,
              [2] = 150669,
              ["Pre"] = 716.7500000000,
          },
          [5] = 
          {
              [1] = 30163,
              [2] = 150669,
              ["Pre"] = 895.4300000000,
          },
          [6] = 
          {
              [1] = 30162,
              [2] = 30164,
              ["Pre"] = 2122.6200000000,
          },
          [7] = 
          {
              [1] = 30157,
              [2] = 30164,
              ["Pre"] = 2141.0300000000,
          },
          [8] = 
          {
              [1] = 150669,
              [2] = 30164,
              ["Pre"] = 2666.0200000000,
          },
          [9] = 
          {
              [1] = 30162,
              [2] = 150731,
              ["Pre"] = 3541.5000000000,
          },
          [10] = 
          {
              [1] = 30157,
              [2] = 150731,
              ["Pre"] = 3559.9100000000,
          },
          [11] = 
          {
              [1] = 30163,
              [2] = 150731,
              ["Pre"] = 3738.5900000000,
          },
          [12] = 
          {
              [1] = 150669,
              [2] = 150731,
              ["Pre"] = 4084.9000000000,
          },
          [13] = 
          {
              [1] = 30164,
              [2] = 150731,
              ["Pre"] = 5509.1800000000,
          },
      },
      [158308] = 
      {
          [1] = 
          {
              [1] = 150672,
              [2] = 150670,
              ["Pre"] = 872.7100000000,
          },
          [2] = 
          {
              [1] = 150672,
              [2] = 150669,
              ["Pre"] = 1033.0700000000,
          },
          [3] = 
          {
              [1] = 150670,
              [2] = 150669,
              ["Pre"] = 1081.3800000000,
          },
      },
      [77596] = 
      {
          [1] = 
          {
              [1] = 77590,
              [2] = 77583,
              ["Pre"] = 340.4900000000,
          },
          [2] = 
          {
              [1] = 77583,
              [2] = 150670,
              ["Pre"] = 670.9700000000,
          },
          [3] = 
          {
              [1] = 77590,
              [2] = 77591,
              ["Pre"] = 772.1600000000,
          },
          [4] = 
          {
              [1] = 150670,
              [2] = 77591,
              ["Pre"] = 1102.6400000000,
          },
          [5] = 
          {
              [1] = 77590,
              [2] = 139019,
              ["Pre"] = 1872.7200000000,
          },
          [6] = 
          {
              [1] = 77583,
              [2] = 139019,
              ["Pre"] = 1953.1500000000,
          },
          [7] = 
          {
              [1] = 150670,
              [2] = 139019,
              ["Pre"] = 2203.2000000000,
          },
          [8] = 
          {
              [1] = 77591,
              [2] = 139019,
              ["Pre"] = 2384.8200000000,
          },
      },
      [151969] = 
      {
          [1] = 
          {
              [1] = 150789,
              [2] = 150731,
              ["Pre"] = 3636.3400000000,
          },
          [2] = 
          {
              [1] = 150789,
              [2] = 150671,
              ["Pre"] = 7550.1000000000,
          },
          [3] = 
          {
              [1] = 150731,
              [2] = 150671,
              ["Pre"] = 10841.8200000000,
          },
      },
      [44809] = 
      {
          [1] = 
          {
              [1] = 77587,
              [2] = 30155,
              ["Pre"] = 168.7200000000,
          },
          [2] = 
          {
              [1] = 77587,
              [2] = 30156,
              ["Pre"] = 187.5500000000,
          },
          [3] = 
          {
              [1] = 77587,
              [2] = 30149,
              ["Pre"] = 192.2600000000,
          },
          [4] = 
          {
              [1] = 30155,
              [2] = 30156,
              ["Pre"] = 192.7500000000,
          },
          [5] = 
          {
              [1] = 30155,
              [2] = 30149,
              ["Pre"] = 197.4600000000,
          },
          [6] = 
          {
              [1] = 77587,
              [2] = 30151,
              ["Pre"] = 203.9800000000,
          },
          [7] = 
          {
              [1] = 30155,
              [2] = 30151,
              ["Pre"] = 209.1800000000,
          },
          [8] = 
          {
              [1] = 30149,
              [2] = 30156,
              ["Pre"] = 216.2900000000,
          },
          [9] = 
          {
              [1] = 30156,
              [2] = 30151,
              ["Pre"] = 228.0100000000,
          },
      },
      [44810] = 
      {
          [1] = 
          {
              [1] = 30155,
              [2] = 30163,
              ["Pre"] = 361.5200000000,
          },
          [2] = 
          {
              [1] = 30156,
              [2] = 30163,
              ["Pre"] = 380.3500000000,
          },
      },
      [27042] = 
      {
          [1] = 
          {
              [1] = 30156,
              [2] = 77583,
              ["Pre"] = 316.2500000000,
          },
          [2] = 
          {
              [1] = 77583,
              [2] = 30163,
              ["Pre"] = 485.0200000000,
          },
          [3] = 
          {
              [1] = 30156,
              [2] = 77591,
              ["Pre"] = 747.9200000000,
          },
          [4] = 
          {
              [1] = 77583,
              [2] = 77591,
              ["Pre"] = 852.5900000000,
          },
          [5] = 
          {
              [1] = 30163,
              [2] = 77591,
              ["Pre"] = 916.6900000000,
          },
      },
      [44812] = 
      {
          [1] = 
          {
              [1] = 30165,
              [2] = 30157,
              ["Pre"] = 186.7600000000,
          },
          [2] = 
          {
              [1] = 30165,
              [2] = 30149,
              ["Pre"] = 201.3800000000,
          },
          [3] = 
          {
              [1] = 30157,
              [2] = 30149,
              ["Pre"] = 206.3800000000,
          },
          [4] = 
          {
              [1] = 30165,
              [2] = 30151,
              ["Pre"] = 213.1000000000,
          },
          [5] = 
          {
              [1] = 30157,
              [2] = 30151,
              ["Pre"] = 218.1000000000,
          },
          [6] = 
          {
              [1] = 30165,
              [2] = 77590,
              ["Pre"] = 220.9100000000,
          },
          [7] = 
          {
              [1] = 30157,
              [2] = 77590,
              ["Pre"] = 225.9100000000,
          },
          [8] = 
          {
              [1] = 30149,
              [2] = 30151,
              ["Pre"] = 232.7200000000,
          },
          [9] = 
          {
              [1] = 30149,
              [2] = 77590,
              ["Pre"] = 240.5300000000,
          },
          [10] = 
          {
              [1] = 77590,
              [2] = 30151,
              ["Pre"] = 252.2500000000,
          },
          [11] = 
          {
              [1] = 30165,
              [2] = 30161,
              ["Pre"] = 253.5600000000,
          },
          [12] = 
          {
              [1] = 30157,
              [2] = 30161,
              ["Pre"] = 258.5600000000,
          },
          [13] = 
          {
              [1] = 30149,
              [2] = 30161,
              ["Pre"] = 273.1800000000,
          },
          [14] = 
          {
              [1] = 30151,
              [2] = 30161,
              ["Pre"] = 284.9000000000,
          },
          [15] = 
          {
              [1] = 77590,
              [2] = 30161,
              ["Pre"] = 292.7100000000,
          },
          [16] = 
          {
              [1] = 30165,
              [2] = 150670,
              ["Pre"] = 551.3900000000,
          },
          [17] = 
          {
              [1] = 30157,
              [2] = 150670,
              ["Pre"] = 556.3900000000,
          },
          [18] = 
          {
              [1] = 30149,
              [2] = 150670,
              ["Pre"] = 571.0100000000,
          },
          [19] = 
          {
              [1] = 30151,
              [2] = 150670,
              ["Pre"] = 582.7300000000,
          },
          [20] = 
          {
              [1] = 77590,
              [2] = 150670,
              ["Pre"] = 590.5400000000,
          },
          [21] = 
          {
              [1] = 30161,
              [2] = 150670,
              ["Pre"] = 623.1900000000,
          },
          [22] = 
          {
              [1] = 30165,
              [2] = 30152,
              ["Pre"] = 1054.2500000000,
          },
          [23] = 
          {
              [1] = 30157,
              [2] = 30152,
              ["Pre"] = 1059.2500000000,
          },
          [24] = 
          {
              [1] = 30149,
              [2] = 30152,
              ["Pre"] = 1073.8700000000,
          },
          [25] = 
          {
              [1] = 30151,
              [2] = 30152,
              ["Pre"] = 1085.5900000000,
          },
          [26] = 
          {
              [1] = 77590,
              [2] = 30152,
              ["Pre"] = 1093.4000000000,
          },
          [27] = 
          {
              [1] = 30161,
              [2] = 30152,
              ["Pre"] = 1126.0500000000,
          },
          [28] = 
          {
              [1] = 150670,
              [2] = 30152,
              ["Pre"] = 1423.8800000000,
          },
      },
      [44813] = 
      {
          [1] = 
          {
              [1] = 30148,
              [2] = 30160,
              ["Pre"] = 415.0700000000,
          },
          [2] = 
          {
              [1] = 30154,
              [2] = 30160,
              ["Pre"] = 415.2900000000,
          },
      },
      [44814] = 
      {
          [1] = 
          {
              [1] = 30154,
              [2] = 77591,
              ["Pre"] = 721.3500000000,
          },
          [2] = 
          {
              [1] = 30154,
              [2] = 139020,
              ["Pre"] = 793.6300000000,
          },
          [3] = 
          {
              [1] = 30160,
              [2] = 77591,
              ["Pre"] = 978.2000000000,
          },
          [4] = 
          {
              [1] = 30160,
              [2] = 139020,
              ["Pre"] = 1050.4800000000,
          },
          [5] = 
          {
              [1] = 77591,
              [2] = 139020,
              ["Pre"] = 1356.5400000000,
          },
      },
      [44815] = 
      {
          [1] = 
          {
              [1] = 30148,
              [2] = 30154,
              ["Pre"] = 158.2200000000,
          },
          [2] = 
          {
              [1] = 30148,
              [2] = 30151,
              ["Pre"] = 201.2200000000,
          },
          [3] = 
          {
              [1] = 30154,
              [2] = 30151,
              ["Pre"] = 201.4400000000,
          },
          [4] = 
          {
              [1] = 30148,
              [2] = 77589,
              ["Pre"] = 503.9200000000,
          },
          [5] = 
          {
              [1] = 30154,
              [2] = 77589,
              ["Pre"] = 504.1400000000,
          },
          [6] = 
          {
              [1] = 30151,
              [2] = 77589,
              ["Pre"] = 547.1400000000,
          },
          [7] = 
          {
              [1] = 30148,
              [2] = 150669,
              ["Pre"] = 699.8700000000,
          },
          [8] = 
          {
              [1] = 30154,
              [2] = 150669,
              ["Pre"] = 700.0900000000,
          },
          [9] = 
          {
              [1] = 30151,
              [2] = 150669,
              ["Pre"] = 743.0900000000,
          },
          [10] = 
          {
              [1] = 30148,
              [2] = 30152,
              ["Pre"] = 1042.3700000000,
          },
          [11] = 
          {
              [1] = 30154,
              [2] = 30152,
              ["Pre"] = 1042.5900000000,
          },
          [12] = 
          {
              [1] = 77589,
              [2] = 150669,
              ["Pre"] = 1045.7900000000,
          },
          [13] = 
          {
              [1] = 77589,
              [2] = 30152,
              ["Pre"] = 1388.2900000000,
          },
          [14] = 
          {
              [1] = 150669,
              [2] = 30152,
              ["Pre"] = 1584.2400000000,
          },
      },
      [77602] = 
      {
          [1] = 
          {
              [1] = 77584,
              [2] = 77590,
              ["Pre"] = 220.1000000000,
          },
          [2] = 
          {
              [1] = 77584,
              [2] = 77591,
              ["Pre"] = 732.2000000000,
          },
          [3] = 
          {
              [1] = 77590,
              [2] = 139020,
              ["Pre"] = 844.4400000000,
          },
          [4] = 
          {
              [1] = 77590,
              [2] = 150731,
              ["Pre"] = 3594.0600000000,
          },
          [5] = 
          {
              [1] = 77591,
              [2] = 150731,
              ["Pre"] = 4106.1600000000,
          },
          [6] = 
          {
              [1] = 139020,
              [2] = 150731,
              ["Pre"] = 4178.4400000000,
          },
      },
      [30145] = 
      {
          [1] = 
          {
              [1] = 30158,
              [2] = 30161,
              ["Pre"] = 266.0400000000,
          },
          [2] = 
          {
              [1] = 30158,
              [2] = 30152,
              ["Pre"] = 1066.7300000000,
          },
      },
      [27041] = 
      {
          [1] = 
          {
              [1] = 30157,
              [2] = 30153,
              ["Pre"] = 186.6400000000,
          },
          [2] = 
          {
              [1] = 30153,
              [2] = 77589,
              ["Pre"] = 515.6800000000,
          },
          [3] = 
          {
              [1] = 30157,
              [2] = 77589,
              ["Pre"] = 520.8000000000,
          },
          [4] = 
          {
              [1] = 30153,
              [2] = 139019,
              ["Pre"] = 1833.4500000000,
          },
          [5] = 
          {
              [1] = 30157,
              [2] = 139019,
              ["Pre"] = 1838.5700000000,
          },
          [6] = 
          {
              [1] = 77589,
              [2] = 139019,
              ["Pre"] = 2167.6100000000,
          },
          [7] = 
          {
              [1] = 30153,
              [2] = 150671,
              ["Pre"] = 7468.5500000000,
          },
          [8] = 
          {
              [1] = 30157,
              [2] = 150671,
              ["Pre"] = 7473.6700000000,
          },
          [9] = 
          {
              [1] = 77589,
              [2] = 150671,
              ["Pre"] = 7802.7100000000,
          },
          [10] = 
          {
              [1] = 139019,
              [2] = 150671,
              ["Pre"] = 9120.4800000000,
          },
      },
      [54333] = 
      {
          [1] = 
          {
              [1] = 30166,
              [2] = 30151,
              ["Pre"] = 221.4700000000,
          },
      },
      [77597] = 
      {
          [1] = 
          {
              [1] = 77590,
              [2] = 77583,
              ["Pre"] = 340.4900000000,
          },
          [2] = 
          {
              [1] = 77583,
              [2] = 150670,
              ["Pre"] = 670.9700000000,
          },
          [3] = 
          {
              [1] = 77590,
              [2] = 77591,
              ["Pre"] = 772.1600000000,
          },
          [4] = 
          {
              [1] = 150670,
              [2] = 77591,
              ["Pre"] = 1102.6400000000,
          },
          [5] = 
          {
              [1] = 77590,
              [2] = 139019,
              ["Pre"] = 1872.7200000000,
          },
          [6] = 
          {
              [1] = 77583,
              [2] = 139019,
              ["Pre"] = 1953.1500000000,
          },
          [7] = 
          {
              [1] = 150670,
              [2] = 139019,
              ["Pre"] = 2203.2000000000,
          },
          [8] = 
          {
              [1] = 77591,
              [2] = 139019,
              ["Pre"] = 2384.8200000000,
          },
      },
      [44821] = 
      {
          [1] = 
          {
              [1] = 30158,
              [2] = 77583,
              ["Pre"] = 313.8200000000,
          },
          [2] = 
          {
              [1] = 77583,
              [2] = 30152,
              ["Pre"] = 1173.8300000000,
          },
      },
      [27039] = 
      {
          [1] = 
          {
              [1] = 30159,
              [2] = 30153,
              ["Pre"] = 181.5600000000,
          },
          [2] = 
          {
              [1] = 30153,
              [2] = 30164,
              ["Pre"] = 2135.9100000000,
          },
          [3] = 
          {
              [1] = 30159,
              [2] = 30164,
              ["Pre"] = 2135.9500000000,
          },
      },
      [152151] = 
      {
          [1] = 
          {
              [1] = 150789,
              [2] = 150731,
              ["Pre"] = 3636.3400000000,
          },
          [2] = 
          {
              [1] = 150789,
              [2] = 150671,
              ["Pre"] = 7550.1000000000,
          },
          [3] = 
          {
              [1] = 150731,
              [2] = 150671,
              ["Pre"] = 10841.8200000000,
          },
      },
      [77592] = 
      {
          [1] = 
          {
              [1] = 77584,
              [2] = 77585,
              ["Pre"] = 195.1400000000,
          },
          [2] = 
          {
              [1] = 77584,
              [2] = 77589,
              ["Pre"] = 514.9900000000,
          },
          [3] = 
          {
              [1] = 77585,
              [2] = 77589,
              ["Pre"] = 529.9900000000,
          },
          [4] = 
          {
              [1] = 77584,
              [2] = 139019,
              ["Pre"] = 1832.7600000000,
          },
          [5] = 
          {
              [1] = 77585,
              [2] = 139019,
              ["Pre"] = 1847.7600000000,
          },
          [6] = 
          {
              [1] = 77584,
              [2] = 150731,
              ["Pre"] = 3554.1000000000,
          },
          [7] = 
          {
              [1] = 77585,
              [2] = 150731,
              ["Pre"] = 3569.1000000000,
          },
          [8] = 
          {
              [1] = 77589,
              [2] = 150731,
              ["Pre"] = 3888.9500000000,
          },
          [9] = 
          {
              [1] = 139019,
              [2] = 150731,
              ["Pre"] = 5206.7200000000,
          },
      },
      [77593] = 
      {
          [1] = 
          {
              [1] = 77584,
              [2] = 77585,
              ["Pre"] = 195.1400000000,
          },
          [2] = 
          {
              [1] = 77584,
              [2] = 77589,
              ["Pre"] = 514.9900000000,
          },
          [3] = 
          {
              [1] = 77585,
              [2] = 77589,
              ["Pre"] = 529.9900000000,
          },
          [4] = 
          {
              [1] = 77584,
              [2] = 139019,
              ["Pre"] = 1832.7600000000,
          },
          [5] = 
          {
              [1] = 77585,
              [2] = 139019,
              ["Pre"] = 1847.7600000000,
          },
          [6] = 
          {
              [1] = 77584,
              [2] = 150731,
              ["Pre"] = 3554.1000000000,
          },
          [7] = 
          {
              [1] = 77585,
              [2] = 150731,
              ["Pre"] = 3569.1000000000,
          },
          [8] = 
          {
              [1] = 77589,
              [2] = 150731,
              ["Pre"] = 3888.9500000000,
          },
          [9] = 
          {
              [1] = 139019,
              [2] = 150731,
              ["Pre"] = 5206.7200000000,
          },
      },
      [76826] = 
      {
          [1] = 
          {
              [1] = 30148,
              [2] = 30155,
              ["Pre"] = 165.9600000000,
          },
          [2] = 
          {
              [1] = 30148,
              [2] = 30166,
              ["Pre"] = 178.2500000000,
          },
          [3] = 
          {
              [1] = 30148,
              [2] = 77585,
              ["Pre"] = 184.0700000000,
          },
          [4] = 
          {
              [1] = 30155,
              [2] = 30166,
              ["Pre"] = 186.2100000000,
          },
          [5] = 
          {
              [1] = 30155,
              [2] = 77585,
              ["Pre"] = 192.0300000000,
          },
          [6] = 
          {
              [1] = 30166,
              [2] = 77585,
              ["Pre"] = 204.3200000000,
          },
          [7] = 
          {
              [1] = 30148,
              [2] = 30163,
              ["Pre"] = 353.5600000000,
          },
          [8] = 
          {
              [1] = 30166,
              [2] = 30163,
              ["Pre"] = 373.8100000000,
          },
          [9] = 
          {
              [1] = 77585,
              [2] = 30163,
              ["Pre"] = 379.6300000000,
          },
          [10] = 
          {
              [1] = 30155,
              [2] = 30160,
              ["Pre"] = 423.0300000000,
          },
          [11] = 
          {
              [1] = 30166,
              [2] = 30160,
              ["Pre"] = 435.3200000000,
          },
          [12] = 
          {
              [1] = 77585,
              [2] = 30160,
              ["Pre"] = 441.1400000000,
          },
          [13] = 
          {
              [1] = 30148,
              [2] = 150672,
              ["Pre"] = 491.2000000000,
          },
          [14] = 
          {
              [1] = 30155,
              [2] = 150672,
              ["Pre"] = 499.1600000000,
          },
          [15] = 
          {
              [1] = 77585,
              [2] = 150672,
              ["Pre"] = 517.2700000000,
          },
          [16] = 
          {
              [1] = 30163,
              [2] = 30160,
              ["Pre"] = 610.6300000000,
          },
          [17] = 
          {
              [1] = 30163,
              [2] = 150672,
              ["Pre"] = 686.7600000000,
          },
          [18] = 
          {
              [1] = 30160,
              [2] = 150672,
              ["Pre"] = 748.2700000000,
          },
          [19] = 
          {
              [1] = 30148,
              [2] = 30164,
              ["Pre"] = 2124.1500000000,
          },
          [20] = 
          {
              [1] = 30155,
              [2] = 30164,
              ["Pre"] = 2132.1100000000,
          },
          [21] = 
          {
              [1] = 30166,
              [2] = 30164,
              ["Pre"] = 2144.4000000000,
          },
          [22] = 
          {
              [1] = 77585,
              [2] = 30164,
              ["Pre"] = 2150.2200000000,
          },
          [23] = 
          {
              [1] = 30163,
              [2] = 30164,
              ["Pre"] = 2319.7100000000,
          },
          [24] = 
          {
              [1] = 30160,
              [2] = 30164,
              ["Pre"] = 2381.2200000000,
          },
          [25] = 
          {
              [1] = 150672,
              [2] = 30164,
              ["Pre"] = 2457.3500000000,
          },
      },
      [77595] = 
      {
          [1] = 
          {
              [1] = 77587,
              [2] = 77590,
              ["Pre"] = 211.7900000000,
          },
          [2] = 
          {
              [1] = 77587,
              [2] = 150672,
              ["Pre"] = 493.9600000000,
          },
          [3] = 
          {
              [1] = 77590,
              [2] = 150672,
              ["Pre"] = 542.2300000000,
          },
      },
      [76828] = 
      {
          [1] = 
          {
              [1] = 30158,
              [2] = 30160,
              ["Pre"] = 439.4300000000,
          },
          [2] = 
          {
              [1] = 30161,
              [2] = 30160,
              ["Pre"] = 498.7500000000,
          },
          [3] = 
          {
              [1] = 30158,
              [2] = 150670,
              ["Pre"] = 563.8700000000,
          },
          [4] = 
          {
              [1] = 30160,
              [2] = 150670,
              ["Pre"] = 796.5800000000,
          },
          [5] = 
          {
              [1] = 30158,
              [2] = 30164,
              ["Pre"] = 2148.5100000000,
          },
          [6] = 
          {
              [1] = 30161,
              [2] = 30164,
              ["Pre"] = 2207.8300000000,
          },
          [7] = 
          {
              [1] = 150670,
              [2] = 30164,
              ["Pre"] = 2505.6600000000,
          },
          [8] = 
          {
              [1] = 30158,
              [2] = 150671,
              ["Pre"] = 7481.1500000000,
          },
          [9] = 
          {
              [1] = 30161,
              [2] = 150671,
              ["Pre"] = 7540.4700000000,
          },
          [10] = 
          {
              [1] = 30160,
              [2] = 150671,
              ["Pre"] = 7713.8600000000,
          },
          [11] = 
          {
              [1] = 150670,
              [2] = 150671,
              ["Pre"] = 7838.3000000000,
          },
          [12] = 
          {
              [1] = 30164,
              [2] = 150671,
              ["Pre"] = 9422.9400000000,
          },
      },
      [76829] = 
      {
          [1] = 
          {
              [1] = 30148,
              [2] = 30154,
              ["Pre"] = 158.2200000000,
          },
          [2] = 
          {
              [1] = 30148,
              [2] = 30151,
              ["Pre"] = 201.2200000000,
          },
          [3] = 
          {
              [1] = 30154,
              [2] = 30151,
              ["Pre"] = 201.4400000000,
          },
          [4] = 
          {
              [1] = 30148,
              [2] = 77589,
              ["Pre"] = 503.9200000000,
          },
          [5] = 
          {
              [1] = 30154,
              [2] = 77589,
              ["Pre"] = 504.1400000000,
          },
          [6] = 
          {
              [1] = 30151,
              [2] = 77589,
              ["Pre"] = 547.1400000000,
          },
          [7] = 
          {
              [1] = 30148,
              [2] = 150669,
              ["Pre"] = 699.8700000000,
          },
          [8] = 
          {
              [1] = 30154,
              [2] = 150669,
              ["Pre"] = 700.0900000000,
          },
          [9] = 
          {
              [1] = 30151,
              [2] = 150669,
              ["Pre"] = 743.0900000000,
          },
          [10] = 
          {
              [1] = 30148,
              [2] = 30152,
              ["Pre"] = 1042.3700000000,
          },
          [11] = 
          {
              [1] = 30154,
              [2] = 30152,
              ["Pre"] = 1042.5900000000,
          },
          [12] = 
          {
              [1] = 77589,
              [2] = 150669,
              ["Pre"] = 1045.7900000000,
          },
          [13] = 
          {
              [1] = 77589,
              [2] = 30152,
              ["Pre"] = 1388.2900000000,
          },
          [14] = 
          {
              [1] = 150669,
              [2] = 30152,
              ["Pre"] = 1584.2400000000,
          },
      },
      [76830] = 
      {
          [1] = 
          {
              [1] = 30162,
              [2] = 30163,
              ["Pre"] = 352.0300000000,
          },
          [2] = 
          {
              [1] = 30157,
              [2] = 30163,
              ["Pre"] = 370.4400000000,
          },
          [3] = 
          {
              [1] = 30162,
              [2] = 150669,
              ["Pre"] = 698.3400000000,
          },
          [4] = 
          {
              [1] = 30157,
              [2] = 150669,
              ["Pre"] = 716.7500000000,
          },
          [5] = 
          {
              [1] = 30163,
              [2] = 150669,
              ["Pre"] = 895.4300000000,
          },
          [6] = 
          {
              [1] = 30162,
              [2] = 30164,
              ["Pre"] = 2122.6200000000,
          },
          [7] = 
          {
              [1] = 30157,
              [2] = 30164,
              ["Pre"] = 2141.0300000000,
          },
          [8] = 
          {
              [1] = 150669,
              [2] = 30164,
              ["Pre"] = 2666.0200000000,
          },
          [9] = 
          {
              [1] = 30162,
              [2] = 150731,
              ["Pre"] = 3541.5000000000,
          },
          [10] = 
          {
              [1] = 30157,
              [2] = 150731,
              ["Pre"] = 3559.9100000000,
          },
          [11] = 
          {
              [1] = 30163,
              [2] = 150731,
              ["Pre"] = 3738.5900000000,
          },
          [12] = 
          {
              [1] = 150669,
              [2] = 150731,
              ["Pre"] = 4084.9000000000,
          },
          [13] = 
          {
              [1] = 30164,
              [2] = 150731,
              ["Pre"] = 5509.1800000000,
          },
      },
      [76831] = 
      {
          [1] = 
          {
              [1] = 77587,
              [2] = 30155,
              ["Pre"] = 168.7200000000,
          },
          [2] = 
          {
              [1] = 77587,
              [2] = 30156,
              ["Pre"] = 187.5500000000,
          },
          [3] = 
          {
              [1] = 77587,
              [2] = 30149,
              ["Pre"] = 192.2600000000,
          },
          [4] = 
          {
              [1] = 30155,
              [2] = 30156,
              ["Pre"] = 192.7500000000,
          },
          [5] = 
          {
              [1] = 30155,
              [2] = 30149,
              ["Pre"] = 197.4600000000,
          },
          [6] = 
          {
              [1] = 77587,
              [2] = 30151,
              ["Pre"] = 203.9800000000,
          },
          [7] = 
          {
              [1] = 30155,
              [2] = 30151,
              ["Pre"] = 209.1800000000,
          },
          [8] = 
          {
              [1] = 30149,
              [2] = 30156,
              ["Pre"] = 216.2900000000,
          },
          [9] = 
          {
              [1] = 30156,
              [2] = 30151,
              ["Pre"] = 228.0100000000,
          },
      },
      [76832] = 
      {
          [1] = 
          {
              [1] = 30154,
              [2] = 77591,
              ["Pre"] = 721.3500000000,
          },
          [2] = 
          {
              [1] = 30154,
              [2] = 139020,
              ["Pre"] = 793.6300000000,
          },
          [3] = 
          {
              [1] = 30160,
              [2] = 77591,
              ["Pre"] = 978.2000000000,
          },
          [4] = 
          {
              [1] = 30160,
              [2] = 139020,
              ["Pre"] = 1050.4800000000,
          },
          [5] = 
          {
              [1] = 77591,
              [2] = 139020,
              ["Pre"] = 1356.5400000000,
          },
      },
      [76833] = 
      {
          [1] = 
          {
              [1] = 30158,
              [2] = 77583,
              ["Pre"] = 313.8200000000,
          },
          [2] = 
          {
              [1] = 77583,
              [2] = 30152,
              ["Pre"] = 1173.8300000000,
          },
      },
      [76834] = 
      {
          [1] = 
          {
              [1] = 30156,
              [2] = 77583,
              ["Pre"] = 316.2500000000,
          },
          [2] = 
          {
              [1] = 77583,
              [2] = 30163,
              ["Pre"] = 485.0200000000,
          },
          [3] = 
          {
              [1] = 30156,
              [2] = 77591,
              ["Pre"] = 747.9200000000,
          },
          [4] = 
          {
              [1] = 77583,
              [2] = 77591,
              ["Pre"] = 852.5900000000,
          },
          [5] = 
          {
              [1] = 30163,
              [2] = 77591,
              ["Pre"] = 916.6900000000,
          },
      },
      [77603] = 
      {
          [1] = 
          {
              [1] = 77584,
              [2] = 77590,
              ["Pre"] = 220.1000000000,
          },
          [2] = 
          {
              [1] = 77584,
              [2] = 77591,
              ["Pre"] = 732.2000000000,
          },
          [3] = 
          {
              [1] = 77590,
              [2] = 139020,
              ["Pre"] = 844.4400000000,
          },
          [4] = 
          {
              [1] = 77590,
              [2] = 150731,
              ["Pre"] = 3594.0600000000,
          },
          [5] = 
          {
              [1] = 77591,
              [2] = 150731,
              ["Pre"] = 4106.1600000000,
          },
          [6] = 
          {
              [1] = 139020,
              [2] = 150731,
              ["Pre"] = 4178.4400000000,
          },
      },
      [76836] = 
      {
          [1] = 
          {
              [1] = 30158,
              [2] = 30161,
              ["Pre"] = 266.0400000000,
          },
          [2] = 
          {
              [1] = 30158,
              [2] = 30152,
              ["Pre"] = 1066.7300000000,
          },
      },
      [158309] = 
      {
          [1] = 
          {
              [1] = 150672,
              [2] = 150670,
              ["Pre"] = 872.7100000000,
          },
          [2] = 
          {
              [1] = 150672,
              [2] = 150669,
              ["Pre"] = 1033.0700000000,
          },
          [3] = 
          {
              [1] = 150670,
              [2] = 150669,
              ["Pre"] = 1081.3800000000,
          },
      },
      [76838] = 
      {
          [1] = 
          {
              [1] = 30162,
              [2] = 30157,
              ["Pre"] = 173.3500000000,
          },
          [2] = 
          {
              [1] = 30162,
              [2] = 30149,
              ["Pre"] = 187.9700000000,
          },
      },
      [76839] = 
      {
          [1] = 
          {
              [1] = 30155,
              [2] = 30163,
              ["Pre"] = 361.5200000000,
          },
          [2] = 
          {
              [1] = 30156,
              [2] = 30163,
              ["Pre"] = 380.3500000000,
          },
      },
      [76840] = 
      {
          [1] = 
          {
              [1] = 30166,
              [2] = 30153,
              ["Pre"] = 190.0100000000,
          },
          [2] = 
          {
              [1] = 30153,
              [2] = 30158,
              ["Pre"] = 194.1200000000,
          },
          [3] = 
          {
              [1] = 30166,
              [2] = 30158,
              ["Pre"] = 202.6100000000,
          },
          [4] = 
          {
              [1] = 30153,
              [2] = 150672,
              ["Pre"] = 502.9600000000,
          },
          [5] = 
          {
              [1] = 30166,
              [2] = 150672,
              ["Pre"] = 511.4500000000,
          },
          [6] = 
          {
              [1] = 30158,
              [2] = 150672,
              ["Pre"] = 515.5600000000,
          },
      },
      [76841] = 
      {
          [1] = 
          {
              [1] = 30165,
              [2] = 77585,
              ["Pre"] = 195.9500000000,
          },
      },
      [76842] = 
      {
          [1] = 
          {
              [1] = 30162,
              [2] = 30159,
              ["Pre"] = 168.2700000000,
          },
          [2] = 
          {
              [1] = 30162,
              [2] = 30166,
              ["Pre"] = 176.7200000000,
          },
          [3] = 
          {
              [1] = 30159,
              [2] = 30166,
              ["Pre"] = 190.0500000000,
          },
      },
      [76843] = 
      {
          [1] = 
          {
              [1] = 30165,
              [2] = 30156,
              ["Pre"] = 196.6700000000,
          },
          [2] = 
          {
              [1] = 30165,
              [2] = 77581,
              ["Pre"] = 790.0800000000,
          },
          [3] = 
          {
              [1] = 30156,
              [2] = 77581,
              ["Pre"] = 804.9900000000,
          },
          [4] = 
          {
              [1] = 30165,
              [2] = 150671,
              ["Pre"] = 7468.6700000000,
          },
          [5] = 
          {
              [1] = 30156,
              [2] = 150671,
              ["Pre"] = 7483.5800000000,
          },
          [6] = 
          {
              [1] = 77581,
              [2] = 150671,
              ["Pre"] = 8076.9900000000,
          },
      },
      [76844] = 
      {
          [1] = 
          {
              [1] = 30159,
              [2] = 30153,
              ["Pre"] = 181.5600000000,
          },
          [2] = 
          {
              [1] = 30153,
              [2] = 30164,
              ["Pre"] = 2135.9100000000,
          },
          [3] = 
          {
              [1] = 30159,
              [2] = 30164,
              ["Pre"] = 2135.9500000000,
          },
      },
      [76845] = 
      {
          [1] = 
          {
              [1] = 30166,
              [2] = 30151,
              ["Pre"] = 221.4700000000,
          },
      },
      [76846] = 
      {
          [1] = 
          {
              [1] = 30154,
              [2] = 30159,
              ["Pre"] = 170.0200000000,
          },
          [2] = 
          {
              [1] = 30154,
              [2] = 30161,
              ["Pre"] = 241.9000000000,
          },
          [3] = 
          {
              [1] = 30159,
              [2] = 30161,
              ["Pre"] = 253.4800000000,
          },
          [4] = 
          {
              [1] = 30159,
              [2] = 150669,
              ["Pre"] = 711.6700000000,
          },
          [5] = 
          {
              [1] = 30154,
              [2] = 77581,
              ["Pre"] = 778.4200000000,
          },
          [6] = 
          {
              [1] = 30161,
              [2] = 150669,
              ["Pre"] = 783.5500000000,
          },
          [7] = 
          {
              [1] = 30159,
              [2] = 77581,
              ["Pre"] = 790,
          },
          [8] = 
          {
              [1] = 30161,
              [2] = 77581,
              ["Pre"] = 861.8800000000,
          },
          [9] = 
          {
              [1] = 77581,
              [2] = 150669,
              ["Pre"] = 1320.0700000000,
          },
      },
      [76847] = 
      {
          [1] = 
          {
              [1] = 30148,
              [2] = 77584,
              ["Pre"] = 169.0700000000,
          },
          [2] = 
          {
              [1] = 30148,
              [2] = 30153,
              ["Pre"] = 169.7600000000,
          },
          [3] = 
          {
              [1] = 30148,
              [2] = 30165,
              ["Pre"] = 169.8800000000,
          },
          [4] = 
          {
              [1] = 77584,
              [2] = 30153,
              ["Pre"] = 180.8300000000,
          },
          [5] = 
          {
              [1] = 77584,
              [2] = 30165,
              ["Pre"] = 180.9500000000,
          },
          [6] = 
          {
              [1] = 30165,
              [2] = 30153,
              ["Pre"] = 181.6400000000,
          },
          [7] = 
          {
              [1] = 30148,
              [2] = 150789,
              ["Pre"] = 251.3100000000,
          },
          [8] = 
          {
              [1] = 77584,
              [2] = 150789,
              ["Pre"] = 262.3800000000,
          },
          [9] = 
          {
              [1] = 30153,
              [2] = 150789,
              ["Pre"] = 263.0700000000,
          },
          [10] = 
          {
              [1] = 30165,
              [2] = 150789,
              ["Pre"] = 263.1900000000,
          },
      },
      [76848] = 
      {
          [1] = 
          {
              [1] = 30157,
              [2] = 30153,
              ["Pre"] = 186.6400000000,
          },
          [2] = 
          {
              [1] = 30153,
              [2] = 77589,
              ["Pre"] = 515.6800000000,
          },
          [3] = 
          {
              [1] = 30157,
              [2] = 77589,
              ["Pre"] = 520.8000000000,
          },
          [4] = 
          {
              [1] = 30153,
              [2] = 139019,
              ["Pre"] = 1833.4500000000,
          },
          [5] = 
          {
              [1] = 30157,
              [2] = 139019,
              ["Pre"] = 1838.5700000000,
          },
          [6] = 
          {
              [1] = 77589,
              [2] = 139019,
              ["Pre"] = 2167.6100000000,
          },
          [7] = 
          {
              [1] = 30153,
              [2] = 150671,
              ["Pre"] = 7468.5500000000,
          },
          [8] = 
          {
              [1] = 30157,
              [2] = 150671,
              ["Pre"] = 7473.6700000000,
          },
          [9] = 
          {
              [1] = 77589,
              [2] = 150671,
              ["Pre"] = 7802.7100000000,
          },
          [10] = 
          {
              [1] = 139019,
              [2] = 150671,
              ["Pre"] = 9120.4800000000,
          },
      },
      [76849] = 
      {
          [1] = 
          {
              [1] = 30155,
              [2] = 77584,
              ["Pre"] = 177.0300000000,
          },
          [2] = 
          {
              [1] = 30159,
              [2] = 30155,
              ["Pre"] = 177.7600000000,
          },
          [3] = 
          {
              [1] = 30159,
              [2] = 77584,
              ["Pre"] = 180.8700000000,
          },
          [4] = 
          {
              [1] = 30155,
              [2] = 139020,
              ["Pre"] = 801.3700000000,
          },
          [5] = 
          {
              [1] = 77584,
              [2] = 139020,
              ["Pre"] = 804.4800000000,
          },
          [6] = 
          {
              [1] = 30159,
              [2] = 139020,
              ["Pre"] = 805.2100000000,
          },
      },
      [77599] = 
      {
          [1] = 
          {
              [1] = 77587,
              [2] = 150789,
              ["Pre"] = 254.0700000000,
          },
          [2] = 
          {
              [1] = 77587,
              [2] = 77589,
              ["Pre"] = 506.6800000000,
          },
          [3] = 
          {
              [1] = 150789,
              [2] = 77589,
              ["Pre"] = 597.2300000000,
          },
          [4] = 
          {
              [1] = 77587,
              [2] = 139020,
              ["Pre"] = 796.1700000000,
          },
          [5] = 
          {
              [1] = 150789,
              [2] = 139020,
              ["Pre"] = 886.7200000000,
          },
          [6] = 
          {
              [1] = 77589,
              [2] = 139020,
              ["Pre"] = 1139.3300000000,
          },
      },
      [76827] = 
      {
          [1] = 
          {
              [1] = 30165,
              [2] = 30157,
              ["Pre"] = 186.7600000000,
          },
          [2] = 
          {
              [1] = 30165,
              [2] = 30149,
              ["Pre"] = 201.3800000000,
          },
          [3] = 
          {
              [1] = 30157,
              [2] = 30149,
              ["Pre"] = 206.3800000000,
          },
          [4] = 
          {
              [1] = 30165,
              [2] = 30151,
              ["Pre"] = 213.1000000000,
          },
          [5] = 
          {
              [1] = 30157,
              [2] = 30151,
              ["Pre"] = 218.1000000000,
          },
          [6] = 
          {
              [1] = 30165,
              [2] = 77590,
              ["Pre"] = 220.9100000000,
          },
          [7] = 
          {
              [1] = 30157,
              [2] = 77590,
              ["Pre"] = 225.9100000000,
          },
          [8] = 
          {
              [1] = 30149,
              [2] = 30151,
              ["Pre"] = 232.7200000000,
          },
          [9] = 
          {
              [1] = 30149,
              [2] = 77590,
              ["Pre"] = 240.5300000000,
          },
          [10] = 
          {
              [1] = 77590,
              [2] = 30151,
              ["Pre"] = 252.2500000000,
          },
          [11] = 
          {
              [1] = 30165,
              [2] = 30161,
              ["Pre"] = 253.5600000000,
          },
          [12] = 
          {
              [1] = 30157,
              [2] = 30161,
              ["Pre"] = 258.5600000000,
          },
          [13] = 
          {
              [1] = 30149,
              [2] = 30161,
              ["Pre"] = 273.1800000000,
          },
          [14] = 
          {
              [1] = 30151,
              [2] = 30161,
              ["Pre"] = 284.9000000000,
          },
          [15] = 
          {
              [1] = 77590,
              [2] = 30161,
              ["Pre"] = 292.7100000000,
          },
          [16] = 
          {
              [1] = 30165,
              [2] = 150670,
              ["Pre"] = 551.3900000000,
          },
          [17] = 
          {
              [1] = 30157,
              [2] = 150670,
              ["Pre"] = 556.3900000000,
          },
          [18] = 
          {
              [1] = 30149,
              [2] = 150670,
              ["Pre"] = 571.0100000000,
          },
          [19] = 
          {
              [1] = 30151,
              [2] = 150670,
              ["Pre"] = 582.7300000000,
          },
          [20] = 
          {
              [1] = 77590,
              [2] = 150670,
              ["Pre"] = 590.5400000000,
          },
          [21] = 
          {
              [1] = 30161,
              [2] = 150670,
              ["Pre"] = 623.1900000000,
          },
          [22] = 
          {
              [1] = 30165,
              [2] = 30152,
              ["Pre"] = 1054.2500000000,
          },
          [23] = 
          {
              [1] = 30157,
              [2] = 30152,
              ["Pre"] = 1059.2500000000,
          },
          [24] = 
          {
              [1] = 30149,
              [2] = 30152,
              ["Pre"] = 1073.8700000000,
          },
          [25] = 
          {
              [1] = 30151,
              [2] = 30152,
              ["Pre"] = 1085.5900000000,
          },
          [26] = 
          {
              [1] = 77590,
              [2] = 30152,
              ["Pre"] = 1093.4000000000,
          },
          [27] = 
          {
              [1] = 30161,
              [2] = 30152,
              ["Pre"] = 1126.0500000000,
          },
          [28] = 
          {
              [1] = 150670,
              [2] = 30152,
              ["Pre"] = 1423.8800000000,
          },
      },
      [27040] = 
      {
          [1] = 
          {
              [1] = 30162,
              [2] = 77581,
              ["Pre"] = 776.6700000000,
          },
          [2] = 
          {
              [1] = 30149,
              [2] = 77581,
              ["Pre"] = 809.7000000000,
          },
      },
      [44714] = 
      {
          [1] = 
          {
              [1] = 30162,
              [2] = 30157,
              ["Pre"] = 173.3500000000,
          },
          [2] = 
          {
              [1] = 30162,
              [2] = 30149,
              ["Pre"] = 187.9700000000,
          },
      },
      [44715] = 
      {
          [1] = 
          {
              [1] = 30148,
              [2] = 77584,
              ["Pre"] = 169.0700000000,
          },
          [2] = 
          {
              [1] = 30148,
              [2] = 30153,
              ["Pre"] = 169.7600000000,
          },
          [3] = 
          {
              [1] = 30148,
              [2] = 30165,
              ["Pre"] = 169.8800000000,
          },
          [4] = 
          {
              [1] = 77584,
              [2] = 30153,
              ["Pre"] = 180.8300000000,
          },
          [5] = 
          {
              [1] = 77584,
              [2] = 30165,
              ["Pre"] = 180.9500000000,
          },
          [6] = 
          {
              [1] = 30165,
              [2] = 30153,
              ["Pre"] = 181.6400000000,
          },
          [7] = 
          {
              [1] = 30148,
              [2] = 150789,
              ["Pre"] = 251.3100000000,
          },
          [8] = 
          {
              [1] = 77584,
              [2] = 150789,
              ["Pre"] = 262.3800000000,
          },
          [9] = 
          {
              [1] = 30153,
              [2] = 150789,
              ["Pre"] = 263.0700000000,
          },
          [10] = 
          {
              [1] = 30165,
              [2] = 150789,
              ["Pre"] = 263.1900000000,
          },
      },
      [77594] = 
      {
          [1] = 
          {
              [1] = 77587,
              [2] = 77590,
              ["Pre"] = 211.7900000000,
          },
          [2] = 
          {
              [1] = 77587,
              [2] = 150672,
              ["Pre"] = 493.9600000000,
          },
          [3] = 
          {
              [1] = 77590,
              [2] = 150672,
              ["Pre"] = 542.2300000000,
          },
      },
      [77598] = 
      {
          [1] = 
          {
              [1] = 77587,
              [2] = 150789,
              ["Pre"] = 254.0700000000,
          },
          [2] = 
          {
              [1] = 77587,
              [2] = 77589,
              ["Pre"] = 506.6800000000,
          },
          [3] = 
          {
              [1] = 150789,
              [2] = 77589,
              ["Pre"] = 597.2300000000,
          },
          [4] = 
          {
              [1] = 77587,
              [2] = 139020,
              ["Pre"] = 796.1700000000,
          },
          [5] = 
          {
              [1] = 150789,
              [2] = 139020,
              ["Pre"] = 886.7200000000,
          },
          [6] = 
          {
              [1] = 77589,
              [2] = 139020,
              ["Pre"] = 1139.3300000000,
          },
      },
      [77600] = 
      {
          [1] = 
          {
              [1] = 77587,
              [2] = 77585,
              ["Pre"] = 186.8300000000,
          },
          [2] = 
          {
              [1] = 77585,
              [2] = 150789,
              ["Pre"] = 277.3800000000,
          },
          [3] = 
          {
              [1] = 77587,
              [2] = 77583,
              ["Pre"] = 292.2200000000,
          },
          [4] = 
          {
              [1] = 77585,
              [2] = 77583,
              ["Pre"] = 315.5300000000,
          },
          [5] = 
          {
              [1] = 150789,
              [2] = 77583,
              ["Pre"] = 382.7700000000,
          },
          [6] = 
          {
              [1] = 77587,
              [2] = 77581,
              ["Pre"] = 780.9600000000,
          },
          [7] = 
          {
              [1] = 77585,
              [2] = 77581,
              ["Pre"] = 804.2700000000,
          },
          [8] = 
          {
              [1] = 150789,
              [2] = 77581,
              ["Pre"] = 871.5100000000,
          },
          [9] = 
          {
              [1] = 77583,
              [2] = 77581,
              ["Pre"] = 909.6600000000,
          },
          [10] = 
          {
              [1] = 77587,
              [2] = 139019,
              ["Pre"] = 1824.4500000000,
          },
          [11] = 
          {
              [1] = 150789,
              [2] = 139019,
              ["Pre"] = 1915,
          },
          [12] = 
          {
              [1] = 77581,
              [2] = 139019,
              ["Pre"] = 2441.8900000000,
          },
      },
      [77601] = 
      {
          [1] = 
          {
              [1] = 77587,
              [2] = 77585,
              ["Pre"] = 186.8300000000,
          },
          [2] = 
          {
              [1] = 77585,
              [2] = 150789,
              ["Pre"] = 277.3800000000,
          },
          [3] = 
          {
              [1] = 77587,
              [2] = 77583,
              ["Pre"] = 292.2200000000,
          },
          [4] = 
          {
              [1] = 77585,
              [2] = 77583,
              ["Pre"] = 315.5300000000,
          },
          [5] = 
          {
              [1] = 150789,
              [2] = 77583,
              ["Pre"] = 382.7700000000,
          },
          [6] = 
          {
              [1] = 77587,
              [2] = 77581,
              ["Pre"] = 780.9600000000,
          },
          [7] = 
          {
              [1] = 77585,
              [2] = 77581,
              ["Pre"] = 804.2700000000,
          },
          [8] = 
          {
              [1] = 150789,
              [2] = 77581,
              ["Pre"] = 871.5100000000,
          },
          [9] = 
          {
              [1] = 77583,
              [2] = 77581,
              ["Pre"] = 909.6600000000,
          },
          [10] = 
          {
              [1] = 77587,
              [2] = 139019,
              ["Pre"] = 1824.4500000000,
          },
          [11] = 
          {
              [1] = 150789,
              [2] = 139019,
              ["Pre"] = 1915,
          },
          [12] = 
          {
              [1] = 77581,
              [2] = 139019,
              ["Pre"] = 2441.8900000000,
          },
      },
      [76835] = 
      {
          [1] = 
          {
              [1] = 30162,
              [2] = 77581,
              ["Pre"] = 776.6700000000,
          },
          [2] = 
          {
              [1] = 30149,
              [2] = 77581,
              ["Pre"] = 809.7000000000,
          },
      },
      [76837] = 
      {
          [1] = 
          {
              [1] = 30148,
              [2] = 30160,
              ["Pre"] = 415.0700000000,
          },
          [2] = 
          {
              [1] = 30154,
              [2] = 30160,
              ["Pre"] = 415.2900000000,
          },
      },
      [30141] = 
      {
          [1] = 
          {
              [1] = 30166,
              [2] = 30153,
              ["Pre"] = 190.0100000000,
          },
          [2] = 
          {
              [1] = 30153,
              [2] = 30158,
              ["Pre"] = 194.1200000000,
          },
          [3] = 
          {
              [1] = 30166,
              [2] = 30158,
              ["Pre"] = 202.6100000000,
          },
          [4] = 
          {
              [1] = 30153,
              [2] = 150672,
              ["Pre"] = 502.9600000000,
          },
          [5] = 
          {
              [1] = 30166,
              [2] = 150672,
              ["Pre"] = 511.4500000000,
          },
          [6] = 
          {
              [1] = 30158,
              [2] = 150672,
              ["Pre"] = 515.5600000000,
          },
      },
      [30142] = 
      {
          [1] = 
          {
              [1] = 30154,
              [2] = 30159,
              ["Pre"] = 170.0200000000,
          },
          [2] = 
          {
              [1] = 30154,
              [2] = 30161,
              ["Pre"] = 241.9000000000,
          },
          [3] = 
          {
              [1] = 30159,
              [2] = 30161,
              ["Pre"] = 253.4800000000,
          },
          [4] = 
          {
              [1] = 30159,
              [2] = 150669,
              ["Pre"] = 711.6700000000,
          },
          [5] = 
          {
              [1] = 30154,
              [2] = 77581,
              ["Pre"] = 778.4200000000,
          },
          [6] = 
          {
              [1] = 30161,
              [2] = 150669,
              ["Pre"] = 783.5500000000,
          },
          [7] = 
          {
              [1] = 30159,
              [2] = 77581,
              ["Pre"] = 790,
          },
          [8] = 
          {
              [1] = 30161,
              [2] = 77581,
              ["Pre"] = 861.8800000000,
          },
          [9] = 
          {
              [1] = 77581,
              [2] = 150669,
              ["Pre"] = 1320.0700000000,
          },
      },
      [54335] = 
      {
          [1] = 
          {
              [1] = 30155,
              [2] = 77584,
              ["Pre"] = 177.0300000000,
          },
          [2] = 
          {
              [1] = 30159,
              [2] = 30155,
              ["Pre"] = 177.7600000000,
          },
          [3] = 
          {
              [1] = 30159,
              [2] = 77584,
              ["Pre"] = 180.8700000000,
          },
          [4] = 
          {
              [1] = 30155,
              [2] = 139020,
              ["Pre"] = 801.3700000000,
          },
          [5] = 
          {
              [1] = 77584,
              [2] = 139020,
              ["Pre"] = 804.4800000000,
          },
          [6] = 
          {
              [1] = 30159,
              [2] = 139020,
              ["Pre"] = 805.2100000000,
          },
      },
    }
--Nothing here ~



