DsRGuildPrecrafter         = ZO_Object:Subclass()
DsRGuildPrecrafter.name    = "DsRGuildPrecrafter"

local QUEUE_SIZE = 37 -- Mindestzahl an Platz im Inventar. Entspricht 1 Rotation!!

function DsRGuildPrecrafter.OnAddOnLoaded(event, addonName)
    EVENT_MANAGER:UnregisterForEvent(DsRGuildPrecrafter.name, EVENT_ADD_ON_LOADED)
    DsRGuildPrecrafterQueue:New()
end

function DsRGuildPrecrafter:SetCraftingQueue(multiplier)
    local queue = {}
    for profession, enabled in pairs(DsRGuildPrecrafter:GetSettings().PreCraftProfessions) do
        if enabled then table.insert(queue, profession) end
    end
    if #queue == 0 then
        echo(zo_strformat(GetString(DsRGuildCrafting_PrecraftNoProfessions)))
        return 
    end
    for k, v in pairs(queue) do
        DsRGuildPrecrafterQueue:AddProfession(v, multiplier)
    end
end

function DsRGuildPrecrafter:GetMultiplierAndQueue(args, bagSpace, force)
    local multiplier
    if args == "" then
        if multiplier == 0 and not force then echo(zo_strformat(GetString(DsRGuildCrafting_PrecraftNoInvSpace))) return end
        multiplier = math.floor(bagSpace / QUEUE_SIZE)
    else
        multiplier = tonumber(args) or 1
    end
    if multiplier == 0 then echo(zo_strformat(GetString(DsRGuildCrafting_PrecraftNoZero))) return end
    local multiplierMessage = multiplier .. (multiplier == 1 and GetString(DsRGuildCrafting_PrecraftOneRot) or GetString(DsRGuildCrafting_PrecraftMoreRot))
    d(" |c9fb6cd[DsR-Precrafter]|r " .. GetString(DsRGuildCrafting_PrecraftQueue) .. ": " .. multiplierMessage .. " (" .. multiplier * QUEUE_SIZE .. " items).")
    DsRGuildPrecrafter:SetCraftingQueue(multiplier)
end

function DsRGuildPrecrafter:GetSettings()
    return DsRGuildLoot.sV
end
